using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Genetibase.Network;

namespace RasVPNdemo
{
	/// <summary>
	/// Summary description for VPNDemo.
	/// </summary>
	public class VPNDemo : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ListBox _lb;
		private System.Windows.Forms.Button _btConn;
		private System.Windows.Forms.Label _lbl;
		private Genetibase.Network.NuGenConnect nuGenConnect1;
		private System.Windows.Forms.PropertyGrid pgrpropertyGrid1;
		private System.Windows.Forms.Button _btDisconn;

		public VPNDemo()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this._btConn = new System.Windows.Forms.Button();
			this._lb = new System.Windows.Forms.ListBox();
			this._btDisconn = new System.Windows.Forms.Button();
			this._lbl = new System.Windows.Forms.Label();
			this.nuGenConnect1 = new Genetibase.Network.NuGenConnect();
			this.pgrpropertyGrid1 = new System.Windows.Forms.PropertyGrid();
			this.SuspendLayout();
			// 
			// _btConn
			// 
			this._btConn.Location = new System.Drawing.Point(8, 184);
			this._btConn.Name = "_btConn";
			this._btConn.Size = new System.Drawing.Size(136, 32);
			this._btConn.TabIndex = 0;
			this._btConn.Text = "Establish connection";
			this._btConn.Click += new System.EventHandler(this._btConn_Click);
			// 
			// _lb
			// 
			this._lb.Dock = System.Windows.Forms.DockStyle.Top;
			this._lb.Location = new System.Drawing.Point(0, 0);
			this._lb.Name = "_lb";
			this._lb.Size = new System.Drawing.Size(822, 173);
			this._lb.TabIndex = 1;
			// 
			// _btDisconn
			// 
			this._btDisconn.Location = new System.Drawing.Point(8, 224);
			this._btDisconn.Name = "_btDisconn";
			this._btDisconn.Size = new System.Drawing.Size(136, 32);
			this._btDisconn.TabIndex = 2;
			this._btDisconn.Text = "Break connection";
			this._btDisconn.Click += new System.EventHandler(this._btDisconn_Click);
			// 
			// _lbl
			// 
			this._lbl.BackColor = System.Drawing.Color.PaleTurquoise;
			this._lbl.Font = new System.Drawing.Font("Arial", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this._lbl.ForeColor = System.Drawing.Color.Red;
			this._lbl.Location = new System.Drawing.Point(8, 256);
			this._lbl.Name = "_lbl";
			this._lbl.Size = new System.Drawing.Size(136, 48);
			this._lbl.TabIndex = 3;
			this._lbl.Text = "OFF Line";
			this._lbl.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// nuGenConnect1
			// 
			this.nuGenConnect1.Destination = "192.18.5.1";
			this.nuGenConnect1.EntryName = "testConnect";
			this.nuGenConnect1.Password = "z34YU56fin1_2";
			this.nuGenConnect1.SynchronizingObject = this;
			this.nuGenConnect1.UserName = "smally";
			this.nuGenConnect1.Disconnected += new System.EventHandler(this.nuGenConnect1_Disconnected);
			this.nuGenConnect1.Connected += new System.EventHandler(this.nuGenConnect1_Connected);
			// 
			// pgrpropertyGrid1
			// 
			this.pgrpropertyGrid1.CommandsVisibleIfAvailable = true;
			this.pgrpropertyGrid1.LargeButtons = false;
			this.pgrpropertyGrid1.LineColor = System.Drawing.SystemColors.ScrollBar;
			this.pgrpropertyGrid1.Location = new System.Drawing.Point(160, 184);
			this.pgrpropertyGrid1.Name = "pgrpropertyGrid1";
			this.pgrpropertyGrid1.SelectedObject = this.nuGenConnect1;
			this.pgrpropertyGrid1.Size = new System.Drawing.Size(648, 432);
			this.pgrpropertyGrid1.TabIndex = 4;
			this.pgrpropertyGrid1.Text = "propertyGrid1";
			this.pgrpropertyGrid1.ViewBackColor = System.Drawing.SystemColors.Window;
			this.pgrpropertyGrid1.ViewForeColor = System.Drawing.SystemColors.WindowText;
			// 
			// VPNDemo
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(822, 620);
			this.Controls.Add(this.pgrpropertyGrid1);
			this.Controls.Add(this._lbl);
			this.Controls.Add(this._btDisconn);
			this.Controls.Add(this._lb);
			this.Controls.Add(this._btConn);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.Name = "VPNDemo";
			this.Text = "VPN Demo";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new VPNDemo());
		}

		private void _btConn_Click(object sender, System.EventArgs e)
		{
			try
			{
				// create new entry & establish connection
				this.nuGenConnect1.Connect();
			}
			catch(RasException re)
			{
				this._lb.Items.Add(re.Message);
				this._lb.Items.Add("***");
			}
		}

		private void _btDisconn_Click(object sender, System.EventArgs e)
		{
			try
			{
				// break connection established early
				this.nuGenConnect1.Disconnect();
			}
			catch(RasException re)
			{
				this._lb.Items.Add(re.Message);
				this._lb.Items.Add("***");
			}
		}

		// do what we want after successfully connect to server
		private void nuGenConnect1_Connected(object sender, System.EventArgs e)
		{
			this._lbl.ForeColor = Color.LimeGreen;
			this._lbl.Text = "ON Line";
		}

		// do what we want after successfully dis-connect from server
		private void nuGenConnect1_Disconnected(object sender, System.EventArgs e)
		{
			this._lbl.ForeColor = Color.Red;
			this._lbl.Text = "OFF Line";
		}
	}
}
